//+------------------------------------------------------------------+
//|                                           AI_PERCEPTRON's_v1.mq4 |
//|                     Copyright  2006, Yury V. Reshetov |
//|                                         http://reshetov.xnet.uz/ |
//|                   Copyright  2007, Valeriy V. Margorin |
//|                                                      mvv@list.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Yury V. Reshetov, Valeriy V. Margorin"
//---- input parameters
extern int    x1 = 91;
extern int    x2 = 15;
extern int    x3 = 48;
extern int    x4 = 61;
//---- input parameters
extern int    y1 = 193;
extern int    y2 = 19;
extern int    y3 = 157;
extern int    y4 = 120;
//---- input parameters
extern int    z1 = 193;
extern int    z2 = 19;
extern int    z3 = 157;
extern int    z4 = 120;
// StopLoss level
extern double sl = 85;
extern double lots = 1;
extern int MagicNumber = 87878;
static int prevtime = 0;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   if(Time[0] == prevtime) 
       return(0);
   prevtime = Time[0];
   int spread = 3;
//----
   if(IsTradeAllowed()) 
     {
       RefreshRates();
       spread = MarketInfo(Symbol(), MODE_SPREAD);
     } 
   else 
     {
       prevtime = Time[1];
       return(0);
     }
   int ticket = -1;
// check for opened position
   int total = OrdersTotal();   
//----
   for(int i = total - 1; i >= 0; i--) 
     {
       OrderSelect(i, SELECT_BY_POS, MODE_TRADES); 
       // check for symbol & magic number
       if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) 
         {
           int prevticket = OrderTicket();
           // long position is opened
           if(OrderType() == OP_BUY) 
             {
               // check profit 
               if ( Bid > (OrderStopLoss() + (sl * 2  + spread) * Point)            
               || perceptron1() < 0 || perceptron2 () < 0 || perceptron3 () < 0 ) 
                 {               
                   if ( perceptron1() < 0 && perceptron2 () < 0 && perceptron3 () < 0 ) 
                     { // reverse
                       ticket = OrderSend(Symbol(), OP_SELL, lots * 2, Bid, 3, 
                                          Ask + sl * Point, 0, "AI", MagicNumber, 0, Red); 
                       Sleep(30000);
                       //----
                       if(ticket < 0) 
                           prevtime = Time[1];
                       else 
                           OrderCloseBy(ticket, prevticket, Blue);   
                     } 
                   else 
                     { // trailing stop
                       if(!OrderModify(OrderTicket(), OrderOpenPrice(), Bid - sl * Point, 
                          0, 0, Blue)) 
                         {
                           Sleep(30000);
                           prevtime = Time[1];
                         }
                     }
                 }  
               // short position is opened
             } 
           else 
             {
               // check profit 
               if ( Ask < (OrderStopLoss() - (sl * 2 + spread) * Point) 
               || perceptron1 () > 0 || perceptron2 () > 0 || perceptron3 () > 0 ) 
                 {
                   if ( perceptron1 () > 0 && perceptron2 () > 0 && perceptron3 () > 0 ) 
                     { // reverse
                       ticket = OrderSend(Symbol(), OP_BUY, lots * 2, Ask, 3, 
                                          Bid - sl * Point, 0, "AI", MagicNumber, 0, Blue); 
                       Sleep(30000);
                       //----
                       if(ticket < 0) 
                           prevtime = Time[1];
                       else 
                           OrderCloseBy(ticket, prevticket, Blue);   
                     } 
                   else 
                     { // trailing stop
                       if(!OrderModify(OrderTicket(), OrderOpenPrice(), Ask + sl * Point, 
                          0, 0, Blue)) 
                         {
                           Sleep(30000);
                           prevtime = Time[1];
                         }
                     }
                 }  
             }
           // exit
           return(0);
         }
     }
// check for long or short position possibility
   if ( perceptron1 () > 0 && perceptron2 () > 0 && perceptron3 () > 0 ) 
     { //long
       ticket = OrderSend(Symbol(), OP_BUY, lots, Ask, 3, Bid - sl * Point, 0, "AI", 
                          MagicNumber, 0, Blue); 
       //----
       if(ticket < 0) 
         {
           Sleep(30000);
           prevtime = Time[1];
         }
     } 
//   else 
   if ( perceptron1 () < 0 && perceptron2 () < 0 && perceptron3 () < 0 ) 
     { // short
       ticket = OrderSend(Symbol(), OP_SELL, lots, Bid, 3, Ask + sl * Point, 0, "AI", 
                          MagicNumber, 0, Red); 
       if(ticket < 0) 
         {
           Sleep(30000);
           prevtime = Time[1];
         }
     }
//--- exit
   return(0);
  }
//+------------------------------------------------------------------+
//| The PERCEPTRON's - a perceiving and recognizing function         |
//+------------------------------------------------------------------+
double perceptron1 () 
  {
   double w1 = x1 - 100.0;
   double w2 = x2 - 100.0;
   double w3 = x3 - 100.0;
   double w4 = x4 - 100.0;
   double a1 = iAC ( Symbol(), 0, 0 );
   double a2 = iAC ( Symbol(), 0, 7 );
   double a3 = iAC ( Symbol(), 0, 14 );
   double a4 = iAC ( Symbol(), 0, 21 );
   return(w1 * a1 + w2 * a2 + w3 * a3 + w4 * a4);
  }
//+------------------------------------------------------------------+
double perceptron2 ()                            
  {
   double w1 = y1 - 100;
   double w2 = y2 - 100;
   double w3 = y3 - 100;
   double w4 = y4 - 100;
   double a1 = iRSI ( Symbol(), 0, 14, PRICE_CLOSE, 0 );
   double a2 = iRSI ( Symbol(), 0, 14, PRICE_CLOSE, 7 );
   double a3 = iRSI ( Symbol(), 0, 14, PRICE_CLOSE, 14 );
   double a4 = iRSI ( Symbol(), 0, 14, PRICE_CLOSE, 21 );
   return(w1 * a1 + w2 * a2 + w3 * a3 + w4 * a4);
  }
//+------------------------------------------------------------------+
double perceptron3 ()                            
  {
   double w1 = z1 - 100;
   double w2 = z2 - 100;
   double w3 = z3 - 100;
   double w4 = z4 - 100;
   double a1 = iCCI ( Symbol(), 0, 14, PRICE_TYPICAL, 0 );
   double a2 = iCCI ( Symbol(), 0, 14, PRICE_TYPICAL, 7 );
   double a3 = iCCI ( Symbol(), 0, 14, PRICE_TYPICAL, 14 );
   double a4 = iCCI ( Symbol(), 0, 14, PRICE_TYPICAL, 21 );
   return(w1 * a1 + w2 * a2 + w3 * a3 + w4 * a4);
  }
//+------------------------------------------------------------------+

